%define _disable_ld_no_undefined 1

%define _localstatedir 	 /var/run

%define mod_gss_version 1.3.1
%define mod_autohost_version 0.1
%define mod_case_version 0.3
%define mod_shaper_version 0.6.5
%define mod_time_version 2.2.1
%define mod_vroot_version 0.8.3
%define mod_sftp_version 0.9.6

Summary:	Professional FTP Server
Name:		proftpd
Version:	1.3.2
%define subrel 3
Release:	%mkrel 4
License:	GPL
Group:		System/Servers
URL:		http://proftpd.org/
Source0:	ftp://ftp.proftpd.org/distrib/source/proftpd/%{name}-%{version}.tar.gz
Source1:	proftpd.logrotate
Source2: 	proftpd.xinetd
Source3:	proftpd.init
Source4:	proftpd.service
Source5:	basic.conf
Source7:	welcome.msg
Source32:	32_mod_shaper.conf
# http://sourceforge.net/projects/gssmod/
Source100:	http://prdownloads.sourceforge.net/gssmod/mod_gss-%{mod_gss_version}.tar.gz
# from http://www.castaglia.org/proftpd/
Source101:	http://www.castaglia.org/proftpd/modules/proftpd-mod-sftp-%{mod_sftp_version}.tar.gz
Source102:	http://www.castaglia.org/proftpd/modules/proftpd-mod-autohost-%{mod_autohost_version}.tar.bz2
Source103:	http://www.castaglia.org/proftpd/modules/proftpd-mod-case-%{mod_case_version}.tar.bz2
Source104:	http://www.castaglia.org/proftpd/modules/proftpd-mod-shaper-%{mod_shaper_version}.tar.gz
Source105:	http://www.castaglia.org/proftpd/modules/proftpd-mod-time-%{mod_time_version}.tar.bz2
Source108:	http://www.castaglia.org/proftpd/modules/proftpd-mod-vroot-%{mod_vroot_version}.tar.gz
Source200:	anonymous.conf
Patch0:		proftpd-1.3.0-xferstats_logfile_location.diff
Patch1:		proftpd-1.3.0-biarch-utmp.diff
# (pixel): i kept the /lib/security/*.so instead of *.so in the patch to have a smaller patch
# (pixel): spec-helper will clean it up
Patch2:		proftpd-use-system-auth-instead-of-pam_unix.diff
Patch4:		proftpd-1.3.0-installfix.diff
Patch7:		proftpd-1.3.0-change_pam_name.diff
Patch8:		proftpd-1.3.2-mod_time_fix.diff
Patch23:	mod_gss-1.3.0-shared.diff
Patch24:	proftpd-1.3.0-mod_autohost.diff
Patch25:	proftpd-1.3.2-CVE-2009-XXXX.diff
Patch26:	proftpd-1.3.2b-CVE-2009-3736.diff
Patch27:	proftpd-1.3.2-CVE-2009-3555.diff
Patch40:	mod_gss-1.3.0-format_not_a_string_literal_and_no_format_arguments.diff
Patch41:	mod_time-format_not_a_string_literal_and_no_format_arguments.diff
Patch43:	mod_wrap2-format_not_a_string_literal_and_no_format_arguments.diff
Requires:	pam >= 0.59
Requires:	setup >= 2.2.0-21mdk
Requires(post): rpm-helper
Requires(postun): rpm-helper
Requires(preun): rpm-helper
Requires(pre): rpm-helper
BuildRequires:	cap-devel
BuildRequires:	gettext-devel
BuildRequires:	libacl-devel
BuildRequires:	libattr-devel
BuildRequires:	libkrb-devel
BuildRequires:	libtool
BuildRequires:	libtool-devel
BuildRequires:	mysql-devel
BuildRequires:	ncurses-devel
BuildRequires:	openldap-devel
BuildRequires:	openssl-devel
BuildRequires:	pam-devel
BuildRequires:	pkgconfig
BuildRequires:	postgresql-devel
BuildRequires:	sasl-plug-gssapi
BuildRequires:	tcp_wrappers-devel
BuildRequires:	zlib-devel
Provides:	ftpserver
Conflicts:	wu-ftpd
Conflicts:	ncftpd
Conflicts:	beroftpd
Conflicts:	anonftp
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
ProFTPd is an enhanced FTP server with a focus toward simplicity, security, and
ease of configuration.  It features a very Apache-like configuration syntax,
and a highly customizable server infrastructure, including support for multiple
'virtual' FTP servers, anonymous FTP, and permission-based directory
visibility.

This version supports both standalone and xinetd operation.

%package	devel
Summary:	Development files for ProFTPD
Group:		Development/C

%description	devel
This package contains the development headers for ProFTPD

%package	mod_ctrls_admin
Summary:	Module implementing admin control handlers
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ctrls_admin
This module implements administrative control actions for the ftpdctl program.

%package	mod_ifsession
Summary:	Module supporting conditional per-user/group/class configuration contexts
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ifsession
Module supporting conditional per-user/group/class configuration contexts

%package	mod_ldap
Summary:	LDAP password lookup module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ldap
LDAP password lookup module for ProFTPD

%package	mod_quotatab
Summary:	Module for managing FTP byte/file quotas via centralized tables
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab
Module for managing FTP byte/file quotas via centralized tables

%package	mod_quotatab_file
Summary:	Sub-module for managing quota data via file-based tables
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab = %{version}-%{release}
Provides:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab_file
Sub-module for managing quota data via file-based tables

%package	mod_quotatab_ldap
Summary:	Sub-module for obtaining quota information from an LDAP directory
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab = %{version}-%{release}
Provides:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab_ldap
Sub-module for obtaining quota information from an LDAP directory

%package	mod_quotatab_sql
Summary:	Sub-module for managing quota data via SQL-based tables
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab = %{version}-%{release}
Provides:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab_sql
Sub-module for managing quota data via SQL-based tables

%package	mod_quotatab_radius
Summary:	Sub-module for managing quota data via radius
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab = %{version}-%{release}
Provides:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab_radius
Sub-module for managing quota data via radius

%package	mod_radius
Summary:	Module for RADIUS authentication and accounting
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_radius
Module for RADIUS authentication and accounting

%package	mod_ratio
Summary:	Support upload/download ratios
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ratio
Support upload/download ratios

%package	mod_rewrite
Summary:	Module for rewriting FTP commands
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_rewrite
Module for rewriting FTP commands

%package	mod_site_misc
Summary:	Module implementing miscellaneous SITE commands
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_site_misc
Module implementing miscellaneous SITE commands

%package	mod_sql
Summary:	SQL frontend
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-mod_sql_driver = %{version}-%{release}

%description	mod_sql
SQL frontend

%package	mod_sql_mysql
Summary:	Support for connecting to MySQL databases
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_sql = %{version}-%{release}
Provides:	%{name}-mod_sql_driver = %{version}-%{release}

%description	mod_sql_mysql
Support for connecting to MySQL databases

%package	mod_sql_postgres
Summary:	Support for connecting to Postgres databases
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_sql = %{version}-%{release}
Provides:	%{name}-mod_sql_driver = %{version}-%{release}

%description	mod_sql_postgres
Support for connecting to Postgres databases

%package	mod_tls
Summary:	An RFC2228 SSL/TLS module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_tls
An RFC2228 SSL/TLS module for ProFTPD

#%package	mod_facl
#Summary:	POSIX ACL checking code (aka POSIX.1e hell)
#Group:		System/Servers
#Requires:	%{name} = %{version}-%{release}
#
#%description	mod_facl
#POSIX ACL checking code (aka POSIX.1e hell)

%package	mod_autohost
Summary:	An autohost module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_autohost
For sites that run a large number of <VirtualHost>s for proftpd, it can be
cumbersome to configure them all in the proftpd.conf file. Adding or removing
virtual server configurations require restarting the daemon, as do changes to
one of the server configurations. The daemon also consumes memory for each
server configuration, and the memory footprint for the daemon process can grow
large for large numbers of servers.

The mod_autohost module allows for server configurations to be configured in
individual files, and for those configuration to be used in an "on demand"
fashion. Rather than loading the configurations into memory when the daemon
starts up, the daemon will check the IP address and port being contacted by a
connecting client, check in the filesystem for a mod_autohost configuration
file for that address/port, dynamically parse the configuration, and insert
the configuration into the session's process space. Thus changes to the
configuration are seen whenever a client connects, without requiring a daemon
restart. The memory footprint is reduced because proftpd, via mod_autohost,
only reads and uses the needed configuration.

%package	mod_case
Summary:	Makes ProFTPD case insensitive
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_case
The mod_case module is designed to help ProFTPD be case-insensitive, for those
sites that may need it (e.g. those that are migrating from a Windows
environment or have mounted Windows filesystems).

mod_case works by performing two checks on the filename used in FTP commands.
First, mod_case will scan the directory to see if there is already a file whose
name exactly matches the given filename. If not, mod_case will scan the
directory again, this time looking for case-insensitive matches. 

%package	mod_gss
Summary:	A Kerberos 5 GSS module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_gss
A Kerberos 5 GSS module for ProFTPD

%package	mod_load
Summary:	A module that determines average load for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_load
The code for determining load average on a given system is hairy, to say the
least. Unfortunately, it is necessary to do it this way, as there is no
standard method for extracting such information from the kernel. This module
uses code from GNU's make application, which should function properly. If not,
please contact the author as soon as possible.

%package	mod_shaper
Summary:	A shaping module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_shaper
The mod_shaper module is designed to split overall rates, both download and
upload, for the proftpd daemon among all connected FTP clients, shaping each
session to use only a portion of the overall rate. mod_shaper shapes both
transmitted traffic, e.g. bits being downloaded via the RETR command, and
received traffic, e.g. bits being uploaded via the APPE, STOR, and STOU
commands.

%package	mod_time
Summary:	Limits acces based on the time of day and/or the day of the week
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_time
This module is designed to allow for limiting FTP commands based on the time of
day and/or the day of the week. A more detailed explanation of the usage of
this module follows the directive explanations.

%package	mod_wrap
Summary:	Provides tcpwrapper-like access control rules for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-mod_wrap_driver = %{version}-%{release}
Requires:	tcp_wrappers

%description	mod_wrap
The mod_wrap package allows the proftpd daemon to provide tcpwrapper-like
access control rules while running in standalone mode. It also allows for those
access rules to be stored in various formats, such as files (e.g.
/etc/hosts.allow and /etc/hosts.deny) or in SQL tables.

The most current version of mod_wrap's submodules supports storage of access
table information in various formats:

 o mod_wrap_file for file-based access tables
 o mod_wrap_sql for SQL-based access tables

%package	mod_wrap_file
Summary:	A file-specific driver for the mod_wrap module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Provides:	%{name}-mod_wrap_driver = %{version}-%{release}

%description	mod_wrap_file
This submodule provides the file-specific "driver" for storing IP/DNS-based
access control information in files.

%package	mod_wrap_sql
Summary:	A SQL database driver for the mod_wrap module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Provides:	%{name}-mod_wrap_driver = %{version}-%{release}

%description	mod_wrap_sql
This submodule provides the SQL database "driver" for storing IP/DNS-based
access control information in SQL tables.

%package	mod_ban
Summary:	Adds dynamic "ban" lists to ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ban
The mod_ban module is designed to add dynamic "ban" lists to proftpd. A ban
prevents the banned user, host, or class from logging in to the server; it does
not prevent the banned user, host, or class from connecting to the server.
mod_ban is not a firewall. The module also provides automatic bans that are
triggered based on configurable criteria.

%package	mod_vroot
Summary:	Adds virtual chroot capability to ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_vroot
The purpose of this module to is to implement a virtual chroot capability that
does not require root privileges. The mod_vroot module provides this capability
by using ProFTPD's FS API, available as of 1.2.8rc1.

%package	mod_sftp
Summary:	Implements the SSH2 protocol and its SFTP subsystem for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_sftp
The mod_sftp module implements the SSH2 protocol and its SFTP subsystem, for
secure file transfer over an SSH2 connection. The mod_sftp module supports:

 o Public key authentication
 o Password authentication (e.g. user authentication via mod_sql, mod_ldap,
   mod_auth_file, mod_auth_unix, mod_auth_pam)
 o SCP support
 o Quotas (via the mod_quotatab module)
 o FIPS support (see Usage section)
 o Throttled transfers (via TransferRate, and/or the mod_shaper module)
 o Blacklisted public keys
 o Configurable traffic analysis protection
 o Passphrase-protected host keys 

%prep

%setup -q -n %{name}-%{version} -a100 -a101 -a102 -a103 -a104 -a105 -a108

%patch0 -p0 -b .logfile_location
%patch1 -p0 -b .biarch-utmp
%patch2 -p0 -b .pam
%patch4 -p1 -b .installfix
%patch7 -p0 -b .change_pam_name
%patch8 -p0 -b .mod_time_fix

%patch23 -p0 -b .mod_gss
%patch24 -p0 -b .mod_autohost
%patch25 -p0 -b .CVE-2009-XXXX
%patch26 -p0 -b .CVE-2009-3736
%patch27 -p0 -b .CVE-2009-3555

%patch40 -p0 -b .format_not_a_string_literal_and_no_format_arguments
%patch41 -p0 -b .format_not_a_string_literal_and_no_format_arguments
%patch43 -p0 -b .format_not_a_string_literal_and_no_format_arguments

# Mandriva config
mkdir -p Mandriva
install -m0644 %{SOURCE1} Mandriva/proftpd.logrotate
install -m0644 %{SOURCE2} Mandriva/proftpd.xinetd
install -m0644 %{SOURCE3} Mandriva/proftpd.init
install -m0644 %{SOURCE4} Mandriva/proftpd.service
install -m0644 %{SOURCE5} Mandriva/basic.conf
install -m0644 %{SOURCE7} Mandriva/welcome.msg
install -m0644 %{SOURCE32} Mandriva/32_mod_shaper.conf

# lib64 fix
perl -pi -e "s|/usr/lib|%{_libdir}|g" Mandriva/basic.conf

# fix includes, instead of a patch
perl -pi -e "s|\<mysql\.h\>|\<mysql\/mysql\.h\>|g" contrib/mod_sql_mysql.c
#perl -pi -e "s|\<libpq-fe\.h\>|\<pgsql\/libpq-fe\.h\>|g" contrib/mod_sql_postgres.c

%build

%serverbuild

export CFLAGS="$CFLAGS -DLDAP_DEPRECATED -DUSE_LDAP_TLS -DHAVE_OPENSSL"
export LIBS="-L%{_libdir} -lattr"

mv mod_sftp contrib/
pushd contrib/mod_sftp
#rm -f configure
#libtoolize --copy --force; aclocal; autoconf
popd

pushd mod_gss-%{mod_gss_version}
perl -pi -e "s|<gssapi.h>|<gssapi/gssapi.h>|" configure*
perl -pi -e "s|NULL,code|kc,code|" *.in
#libtoolize --copy --force --ltdl
#rm -rf lib/libltdl; mv libltdl lib/
#rm -f configure; autoconf
%configure2_5x --enable-mit
# Workaround a missing dcl in kerberos...
cat >> mod_gss.h <<EOF
#ifndef GSS_C_AF_INET6
#define GSS_C_AF_INET6 24
#endif
EOF
popd

pushd contrib/mod_load
%configure2_5x
popd

pushd contrib/mod_wrap2
%configure2_5x
popd

# put extra modules in place 
for i in `find mod_* -type f -name "*.c"` `find mod_* -type f -name "*.h"`; do
    cp $i contrib/
done

#head -n 190 aclocal.m4 > acinclude.m4
#rm -f aclocal.m4
#libtoolize --copy --force --ltdl
#rm -rf lib/libltdl; mv libltdl lib/
#aclocal; autoconf

%configure2_5x \
    --libexecdir=%{_libdir}/%{name} \
    --enable-auth-pam \
    --enable-cap \
    --disable-facl \
    --enable-dso \
    --enable-nls \
    --enable-openssl \
    --with-lastlog=/var/log/lastlog \
    --enable-ipv6 \
    --enable-shadow \
    --enable-ctrls \
    --with-shared="mod_ratio:mod_tls:mod_radius:mod_ldap:mod_sql:mod_sql_mysql:mod_sql_postgres:mod_rewrite:mod_gss:mod_load:mod_ctrls_admin:mod_quotatab:mod_quotatab_file:mod_quotatab_ldap:mod_quotatab_sql:mod_quotatab_radius:mod_site_misc:mod_wrap2:mod_wrap2_file:mod_wrap2_sql:mod_autohost:mod_case:mod_shaper:mod_ban:mod_vroot:mod_sftp:mod_time:mod_ifsession" \
    --with-modules="mod_readme:mod_auth_pam"

# libcap hack
perl -pi -e "s|/lib/libcap|/blabla|g" Make.rules
echo "#define HAVE_LINUX_CAPABILITY_H 1" >> config.h

make

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_libdir}/%{name}
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}%{_sysconfdir}/%{name}.d
install -d %{buildroot}%{_sysconfdir}/pam.d
install -d %{buildroot}%{_sysconfdir}/xinetd.d
install -d %{buildroot}%{_sysconfdir}/avahi/services
install -d %{buildroot}/var/ftp/pub
install -d %{buildroot}/var/log/%{name}
install -d %{buildroot}/var/run/%{name}

%makeinstall \
    rundir=%{buildroot}/var/run/%{name} \
    LIBEXECDIR=%{buildroot}%{_libdir}/%{name} \
    SHARED_MODULE_DIRS="" \
    pkgconfigdir=%{buildroot}%{_libdir}/pkgconfig

# fix borked pkgconfig file
perl -pi -e "s|^prefix.*|prefix=%{_prefix}|g" %{buildroot}%{_libdir}/pkgconfig/*.pc
perl -pi -e "s|/lib/|/%{_lib}/|g" %{buildroot}%{_libdir}/pkgconfig/*.pc

%makeinstall -C contrib/mod_wrap2 LIBEXECDIR=%{buildroot}%{_libdir}/%{name}
%makeinstall -C contrib/mod_load LIBEXECDIR=%{buildroot}%{_libdir}/%{name}
%makeinstall -C contrib/mod_sftp LIBEXECDIR=%{buildroot}%{_libdir}/%{name}

install -m0644 contrib/dist/rpm/ftp.pamd %{buildroot}%{_sysconfdir}/pam.d/%{name}
install -m0755 contrib/xferstats.holger-preiss %{buildroot}%{_sbindir}

install -m0644 Mandriva/proftpd.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
install -m0644 Mandriva/proftpd.xinetd %{buildroot}%{_sysconfdir}/xinetd.d/%{name}-xinetd
install -m0755 Mandriva/proftpd.init %{buildroot}%{_initrddir}/%{name}
install -m0644 Mandriva/proftpd.service %{buildroot}%{_sysconfdir}/avahi/services/%{name}.service
install -m0644 Mandriva/basic.conf %{buildroot}%{_sysconfdir}/%{name}.conf
install -m0644 Mandriva/welcome.msg %{buildroot}/var/ftp/pub/welcome.msg

install -m0644 %{SOURCE200} %{buildroot}%{_sysconfdir}/proftpd-anonymous.conf

ln -snf %{name} %{buildroot}%{_sbindir}/in.%{name}
ln -snf %{name} %{buildroot}%{_sbindir}/in.ftpd

# config
echo "LoadModule mod_ctrls_admin.c" > %{buildroot}%{_sysconfdir}/%{name}.d/10_mod_ctrls_admin.conf
echo "LoadModule mod_tls.c" > %{buildroot}%{_sysconfdir}/%{name}.d/11_mod_tls.conf
echo "LoadModule mod_sql.c" > %{buildroot}%{_sysconfdir}/%{name}.d/12_mod_sql.conf
echo "LoadModule mod_ldap.c" > %{buildroot}%{_sysconfdir}/%{name}.d/13_mod_ldap.conf
echo "LoadModule mod_sql_mysql.c" > %{buildroot}%{_sysconfdir}/%{name}.d/14_mod_sql_mysql.conf
echo "LoadModule mod_sql_postgres.c" > %{buildroot}%{_sysconfdir}/%{name}.d/15_mod_sql_postgres.conf
echo "LoadModule mod_quotatab.c" > %{buildroot}%{_sysconfdir}/%{name}.d/16_mod_quotatab.conf
echo "LoadModule mod_quotatab_file.c" > %{buildroot}%{_sysconfdir}/%{name}.d/17_mod_quotatab_file.conf
echo "LoadModule mod_quotatab_ldap.c" > %{buildroot}%{_sysconfdir}/%{name}.d/18_mod_quotatab_ldap.conf
echo "LoadModule mod_quotatab_sql.c" > %{buildroot}%{_sysconfdir}/%{name}.d/19_mod_quotatab_sql.conf
echo "LoadModule mod_quotatab_radius.c" > %{buildroot}%{_sysconfdir}/%{name}.d/20_mod_quotatab_radius.conf
echo "LoadModule mod_radius.c" > %{buildroot}%{_sysconfdir}/%{name}.d/20_mod_radius.conf
echo "LoadModule mod_wrap2.c" > %{buildroot}%{_sysconfdir}/%{name}.d/21_mod_wrap2.conf
echo "LoadModule mod_wrap2_file.c" > %{buildroot}%{_sysconfdir}/%{name}.d/22_mod_wrap2_file.conf
echo "LoadModule mod_wrap2_sql.c" > %{buildroot}%{_sysconfdir}/%{name}.d/23_mod_wrap2_sql.conf
echo "LoadModule mod_rewrite.c" > %{buildroot}%{_sysconfdir}/%{name}.d/24_mod_rewrite.conf
echo "LoadModule mod_ratio.c" > %{buildroot}%{_sysconfdir}/%{name}.d/25_mod_ratio.conf
echo "LoadModule mod_gss.c" > %{buildroot}%{_sysconfdir}/%{name}.d/26_mod_gss.conf
echo "LoadModule mod_autohost.c" > %{buildroot}%{_sysconfdir}/%{name}.d/27_mod_autohost.conf
echo "LoadModule mod_case.c" > %{buildroot}%{_sysconfdir}/%{name}.d/28_mod_case.conf
#echo "LoadModule mod_facl.c" > %{buildroot}%{_sysconfdir}/%{name}.d/30_mod_facl.conf
echo "LoadModule mod_load.c" > %{buildroot}%{_sysconfdir}/%{name}.d/31_mod_load.conf
install -m0644 Mandriva/32_mod_shaper.conf %{buildroot}%{_sysconfdir}/%{name}.d/32_mod_shaper.conf
echo "LoadModule mod_site_misc.c" > %{buildroot}%{_sysconfdir}/%{name}.d/33_mod_site_misc.conf
echo "LoadModule mod_time.c" > %{buildroot}%{_sysconfdir}/%{name}.d/34_mod_time.conf
echo "LoadModule mod_ban.c" > %{buildroot}%{_sysconfdir}/%{name}.d/35_mod_ban.conf
echo "LoadModule mod_vroot.c" > %{buildroot}%{_sysconfdir}/%{name}.d/36_mod_vroot.conf
echo "LoadModule mod_sftp.c" > %{buildroot}%{_sysconfdir}/%{name}.d/37_mod_sftp.conf

cat > %{buildroot}%{_sysconfdir}/%{name}.d/99_mod_ifsession.conf << EOF
# keep this module the last one
LoadModule mod_ifsession.c
EOF

cat > README.urpmi << EOF
Mandriva RPM specific notes

modules support
---------------
proftpd-1.3.0 now loads the modules dynamically, very few modules are compiled
into the proftpd binary. The new configuration file /etc/proftpd.conf uses a
"Include /etc/proftpd.d/*.conf" statement which makes proftpd very similar to
how modules are loaded and the configuration of apache-2.x. Because of this you
may have to manually merge your old configuration into the new
/etc/proftpd.conf file.  This is especially true if you are using LDAP, because
then the mod_ldap.so proftpd module will not be automatically loaded. Here is a
list of the modules that are compiled as DSO's:

 o mod_autohost.so         <- NEW
 o mod_ban.so              <- NEW
 o mod_case.so             <- NEW
 o mod_ctrls_admin.so      <- NEW
 o mod_facl.so
 o mod_gss.so
 o mod_ifsession.so
 o mod_ldap.so
 o mod_load.so             <- NEW
 o mod_quotatab.so         <- NEW
 o mod_quotatab_file.so    <- NEW
 o mod_quotatab_ldap.so    <- NEW
 o mod_quotatab_sql.so     <- NEW
 o mod_quotatab_radius.so  <- NEW
 o mod_radius.so
 o mod_ratio.so
 o mod_rewrite.so
 o mod_shaper.so           <- NEW
 o mod_site_misc.so        <- NEW
 o mod_sql.so              <- NEW
 o mod_sql_mysql.so        <- NEW
 o mod_sql_postgres.so     <- NEW
 o mod_time.so             <- NEW
 o mod_tls.so
 o mod_wrap2.so            <- NEW
 o mod_wrap2_file.so       <- NEW
 o mod_wrap2_sql.so        <- NEW
 o mod_vroot.so            <- NEW
 o mod_sftp                <- NEW
 
anonymous access configuration
------------------------------
Starting with 1.3.0-3mdv2007.1, there is no proftpd-anonymous package anymore.
As it is just a configuration issue, providing a dedicated package was a bit
overkill. Samples configuration files are available among normal package
documentation. You may have to update your configuration manually.
EOF


%find_lang %{name}

# cleanup
rm -f %{buildroot}%{_libdir}/%{name}/*.{a,la}
rm -f contrib/README.mod_sql contrib/README.linux-privs

%post
%_post_service %{name}

# xinetd reset
# Only do it if xinetd is there. -- Geoff
if [ -x /usr/sbin/xinetd ];then
%_post_service xinetd
fi

# ftpusers creation
if [ ! -f %{_sysconfdir}/ftpusers ]; then
    touch %{_sysconfdir}/ftpusers
fi

USERS="root bin daemon adm lp sync shutdown halt mail news uucp operator games nobody"
for i in $USERS ;do
        cat %{_sysconfdir}/ftpusers | grep -q "^$i$" || echo $i >> %{_sysconfdir}/ftpusers
done

%pre
%_pre_useradd ftp /var/ftp /bin/false

%postun
%_postun_userdel ftp

%preun
%_preun_service %{name}
if [ "$1" = 0 ]; then
 if [ -d /var/run/%{name} ]; then
  rm -rf /var/run/%{name}/*
 fi
fi

if [ -x /usr/sbin/xinetd ];then
%_post_service xinetd
fi

%post -n %{name}-mod_autohost
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_autohost
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_case
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_case
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ctrls_admin
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ctrls_admin
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

#%post -n %{name}-mod_facl
#service proftpd condrestart > /dev/null 2>/dev/null || :
#    
#%preun -n %{name}-mod_facl
#if [ "$1" = 0 ]; then
#    service proftpd condrestart > /dev/null 2>/dev/null || :
#fi

%post -n %{name}-mod_gss
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_gss
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ifsession
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ifsession
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ldap
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ldap
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_load
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_load
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab_file
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab_file
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab_ldap
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab_ldap
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab_sql
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab_sql
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab_radius
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab_radius
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_radius
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_radius
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ratio
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ratio
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_rewrite
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_rewrite
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_shaper
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_shaper
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_site_misc
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_site_misc
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_sql_mysql
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_sql_mysql
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_sql
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_sql
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_time
service proftpd condrestart > /dev/null 2>/dev/null || :

%preun -n %{name}-mod_time
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_tls
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_tls
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_wrap_file
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_wrap_file
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_wrap
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_wrap
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_wrap_sql
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_wrap_sql
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ban
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ban
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_vroot
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_vroot
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_sftp
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_sftp
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%triggerpostun -- proftpd-anonymous
# this package doesn't exist anymore, but its configuration file may
# be used in current proftpd configuration
if [ -e /etc/proftpd-anonymous.conf.rpmsave ]; then
    mv -f /etc/proftpd-anonymous.conf.rpmsave /etc/proftpd-anonymous.conf
    echo "warning: /etc/proftpd-anonymous.conf.rpmsave restored as /etc/proftpd-anonymous.conf"
fi

%clean
rm -rf %{buildroot}

%files -f %{name}.lang
%defattr(-,root,root)
%doc README* INSTALL NEWS CREDITS COPYING doc/* README.urpmi
%doc sample-configurations/*
%dir %{_sysconfdir}/proftpd.d
%config(noreplace) %{_sysconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}-anonymous.conf
%config(noreplace) %{_sysconfdir}/pam.d/%{name}
%config(noreplace) %{_sysconfdir}/xinetd.d/%{name}-xinetd
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/avahi/services/%{name}.service
%{_initrddir}/%{name}
%{_sbindir}/%{name}
%{_sbindir}/ftpshut
%{_sbindir}/in.ftpd
%{_sbindir}/in.%{name}
%{_sbindir}/xferstats.holger-preiss
%{_bindir}/ftpcount
%{_bindir}/ftpdctl
%{_bindir}/ftptop
%{_bindir}/ftpwho
%{_bindir}/prxs
%dir %{_libdir}/%{name}
%dir /var/ftp
%dir /var/ftp/pub
%config(noreplace) /var/ftp/pub/welcome.msg
%dir /var/run/%{name}
%dir /var/log/%{name}
%{_mandir}/man*/*

%files devel
%defattr(-,root,root)
%doc ChangeLog
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/*.h
%{_libdir}/pkgconfig/*.pc

%files mod_ctrls_admin
%defattr(-,root,root)
%doc doc/contrib/mod_ctrls_admin.html
%config(noreplace) %{_sysconfdir}/%{name}.d/10_mod_ctrls_admin.conf
%{_libdir}/%{name}/mod_ctrls_admin.so

%files mod_ifsession
%defattr(-,root,root)
%doc doc/contrib/mod_ifsession.html
%config(noreplace) %{_sysconfdir}/%{name}.d/99_mod_ifsession.conf
%{_libdir}/%{name}/mod_ifsession.so

%files mod_ldap
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/%{name}.d/13_mod_ldap.conf
%{_libdir}/%{name}/mod_ldap.so

%files mod_quotatab
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab.html
%config(noreplace) %{_sysconfdir}/%{name}.d/16_mod_quotatab.conf
%{_libdir}/%{name}/mod_quotatab.so

%files mod_quotatab_file
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab_file.html
%config(noreplace) %{_sysconfdir}/%{name}.d/17_mod_quotatab_file.conf
%{_libdir}/%{name}/mod_quotatab_file.so

%files mod_quotatab_ldap
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab_ldap.html
%config(noreplace) %{_sysconfdir}/%{name}.d/18_mod_quotatab_ldap.conf
%{_libdir}/%{name}/mod_quotatab_ldap.so

%files mod_quotatab_sql
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab_sql.html
%config(noreplace) %{_sysconfdir}/%{name}.d/19_mod_quotatab_sql.conf
%{_libdir}/%{name}/mod_quotatab_sql.so

%files mod_quotatab_radius
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab_radius.html
%config(noreplace) %{_sysconfdir}/%{name}.d/20_mod_quotatab_radius.conf
%{_libdir}/%{name}/mod_quotatab_radius.so

%files mod_radius
%defattr(-,root,root)
%doc doc/contrib/mod_radius.html
%config(noreplace) %{_sysconfdir}/%{name}.d/20_mod_radius.conf
%{_libdir}/%{name}/mod_radius.so

%files mod_ratio
%defattr(-,root,root)
%doc contrib/README.ratio
%config(noreplace) %{_sysconfdir}/%{name}.d/25_mod_ratio.conf
%{_libdir}/%{name}/mod_ratio.so

%files mod_rewrite
%defattr(-,root,root)
%doc doc/contrib/mod_rewrite.html
%config(noreplace) %{_sysconfdir}/%{name}.d/24_mod_rewrite.conf
%{_libdir}/%{name}/mod_rewrite.so

%files mod_site_misc
%defattr(-,root,root)
%doc doc/contrib/mod_site_misc.html
%config(noreplace) %{_sysconfdir}/%{name}.d/33_mod_site_misc.conf
%{_libdir}/%{name}/mod_site_misc.so

%files mod_sql
%defattr(-,root,root)
%doc doc/contrib/mod_sql.html
%config(noreplace) %{_sysconfdir}/%{name}.d/12_mod_sql.conf
%{_libdir}/%{name}/mod_sql.so

%files mod_sql_mysql
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/%{name}.d/14_mod_sql_mysql.conf
%{_libdir}/%{name}/mod_sql_mysql.so

%files mod_sql_postgres
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/%{name}.d/15_mod_sql_postgres.conf
%{_libdir}/%{name}/mod_sql_postgres.so

%files mod_tls
%defattr(-,root,root)
%doc doc/contrib/mod_tls.html
%config(noreplace) %{_sysconfdir}/%{name}.d/11_mod_tls.conf
%{_libdir}/%{name}/mod_tls.so

#%files mod_facl
#%defattr(-,root,root)
#%config(noreplace) %{_sysconfdir}/%{name}.d/30_mod_facl.conf
#%{_libdir}/%{name}/mod_facl.so

%files mod_autohost
%defattr(-,root,root)
%doc mod_autohost/mod_autohost.html
%config(noreplace) %{_sysconfdir}/%{name}.d/27_mod_autohost.conf
%{_libdir}/%{name}/mod_autohost.so

%files mod_case
%defattr(-,root,root)
%doc mod_case/mod_case.html
%config(noreplace) %{_sysconfdir}/%{name}.d/28_mod_case.conf
%{_libdir}/%{name}/mod_case.so

%files mod_gss
%defattr(-,root,root)
%doc mod_gss-*/COPYING mod_gss-*/mod_gss.html mod_gss-*/README.mod_gss mod_gss-*/rfc1509.txt mod_gss-*/rfc2228.txt
%config(noreplace) %{_sysconfdir}/%{name}.d/26_mod_gss.conf
%{_libdir}/%{name}/mod_gss.so

%files mod_load
%defattr(-,root,root)
%doc doc/contrib/mod_load.html
%config(noreplace) %{_sysconfdir}/%{name}.d/31_mod_load.conf
%{_libdir}/%{name}/mod_load.so

%files mod_shaper
%defattr(-,root,root)
%doc mod_shaper/mod_shaper.html
%config(noreplace) %{_sysconfdir}/%{name}.d/32_mod_shaper.conf
%{_libdir}/%{name}/mod_shaper.so

%files mod_time
%defattr(-,root,root)
%doc mod_time/README mod_time/mod_time.html
%config(noreplace) %{_sysconfdir}/%{name}.d/34_mod_time.conf
%{_libdir}/%{name}/mod_time.so

%files mod_wrap
%defattr(-,root,root)
%doc doc/contrib/mod_wrap2.html
%config(noreplace) %{_sysconfdir}/%{name}.d/21_mod_wrap2.conf
%{_libdir}/%{name}/mod_wrap2.so

%files mod_wrap_file
%defattr(-,root,root)
%doc doc/contrib/mod_wrap2_file.html
%config(noreplace) %{_sysconfdir}/%{name}.d/22_mod_wrap2_file.conf
%{_libdir}/%{name}/mod_wrap2_file.so

%files mod_wrap_sql
%defattr(-,root,root)
%doc doc/contrib/mod_wrap2_sql.html
%config(noreplace) %{_sysconfdir}/%{name}.d/23_mod_wrap2_sql.conf
%{_libdir}/%{name}/mod_wrap2_sql.so

%files mod_ban
%defattr(-,root,root)
%doc doc/contrib/mod_ban.html
%config(noreplace) %{_sysconfdir}/%{name}.d/35_mod_ban.conf
%{_libdir}/%{name}/mod_ban.so

%files mod_vroot
%defattr(-,root,root)
%doc mod_vroot/mod_vroot.html
%config(noreplace) %{_sysconfdir}/%{name}.d/36_mod_vroot.conf
%{_libdir}/%{name}/mod_vroot.so

%files mod_sftp
%defattr(-,root,root)
%doc contrib/mod_sftp/mod_sftp.html
%config(noreplace) %{_sysconfdir}/blacklist.dat
%config(noreplace) %{_sysconfdir}/dhparams.pem
%config(noreplace) %{_sysconfdir}/%{name}.d/37_mod_sftp.conf
%{_libdir}/%{name}/mod_sftp.so


%changelog
* Mon Dec 21 2009 Oden Eriksson <oeriksson@mandriva.com> 1.3.2-4.3mdv2009.1
- P27: security fix for CVE-2009-3555

* Thu Nov 19 2009 Oden Eriksson <oeriksson@mandriva.com> 1.3.2-4.2mdv2009.1
- P26: security fix for CVE-2009-3736

* Fri Oct 23 2009 Oden Eriksson <oeriksson@mandriva.com> 1.3.2-4.1mdv2009.1
- P25: security fix for a similar issue as CVE-2009-2408 (from 1.3.2b)

* Tue Mar 03 2009 Oden Eriksson <oeriksson@mandriva.com> 1.3.2-4mdv2009.1
+ Revision: 348010
- does not work with libtool-2.2.6, so skip regeneration of the autopoo stuff (fixes #47959)
- drop P3, (FORTIFY_SOURCE fix) it was fixed in 1.3.1
- nuke P5 as it was allready applied

* Fri Feb 27 2009 Oden Eriksson <oeriksson@mandriva.com> 1.3.2-3mdv2009.1
+ Revision: 345791
- re-enable the mod_time module (P8)

* Thu Feb 26 2009 Oden Eriksson <oeriksson@mandriva.com> 1.3.2-2mdv2009.1
+ Revision: 345313
- nuke the clamav parts

* Sat Feb 14 2009 Oden Eriksson <oeriksson@mandriva.com> 1.3.2-1mdv2009.1
+ Revision: 340318
- fix deps
- it compiles just fine without the proftpd_modet.patch patch
- rediffed one more patch, duh!
- 1.3.2
- rediffed patches and dropped upstream implemented ones
- fixed fugly autopoo
- disable the build of the mod_time module, someone needs to port it
- added the new mod_sftp module
- updated some of the modules

* Sun Jan 04 2009 Olivier Thauvin <nanardon@mandriva.org> 1.3.1-17mdv2009.1
+ Revision: 324539
- new mod_gss
- new mod_gss

* Wed Dec 17 2008 Oden Eriksson <oeriksson@mandriva.com> 1.3.1-16mdv2009.1
+ Revision: 315161
- rediffed fuzzy patches
- drop the CVE-2007-2165 patch (P26), dupe code caught by --fuzz=0
- fix build with -Werror=format-security (P40,P41,P42,P43)

* Sat Dec 06 2008 Oden Eriksson <oeriksson@mandriva.com> 1.3.1-15mdv2009.1
+ Revision: 311204
- rebuilt against mysql-5.1.30 libs

* Tue Sep 23 2008 Oden Eriksson <oeriksson@mandriva.com> 1.3.1-14mdv2009.0
+ Revision: 287323
- fix "warning: `proftpd' uses 32-bit capabilities (legacy support in use)"
- added the mod_vroot sub package

* Fri Jul 11 2008 Oden Eriksson <oeriksson@mandriva.com> 1.3.1-13mdv2009.0
+ Revision: 233953
- fix build
- use _disable_ld_no_undefined because it's too ugly to fix

  + Thierry Vignaud <tvignaud@mandriva.com>
    - rebuild

* Sat Feb 16 2008 Olivier Thauvin <nanardon@mandriva.org> 1.3.1-11mdv2008.1
+ Revision: 169341
- workaround bs
- workaround header conflicting type on ix86 arch
- bump
- resurrect a proftpd-anonymous config file
- fix initscript

  + Oden Eriksson <oeriksson@mandriva.com>
    - rebuild

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix description-line-too-long
    - rebuild with fixed %%serverbuild macro
    - rebuild
    - do not package big ChangeLog

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Mon Dec 24 2007 Oden Eriksson <oeriksson@mandriva.com> 1.3.1-6mdv2008.1
+ Revision: 137471
- rebuilt against openldap-2.4.7 libs

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Fri Dec 14 2007 Oden Eriksson <oeriksson@mandriva.com> 1.3.1-5mdv2008.1
+ Revision: 120106
- fix #36136 (Proftpd do not start, problem with openssl)

* Mon Nov 12 2007 Funda Wang <fundawang@mandriva.org> 1.3.1-4mdv2008.1
+ Revision: 108182
- rebuild for new lzma

* Tue Oct 30 2007 Oden Eriksson <oeriksson@mandriva.com> 1.3.1-3mdv2008.1
+ Revision: 103799
- fixes #27575
- fix condrestart in the initscript
- fix deps (MySQL-devel/mysql-devel)
- mod_clamav_new 0.5
- fix #27575

* Mon Oct 29 2007 Oden Eriksson <oeriksson@mandriva.com> 1.3.1-2mdv2008.1
+ Revision: 102986
- rebuilt due to package loss

* Thu Oct 11 2007 Oden Eriksson <oeriksson@mandriva.com> 1.3.1-1mdv2008.1
+ Revision: 97136
- 1.3.1
- rediffed P2
- dropped redundant P8

* Wed Aug 15 2007 Oden Eriksson <oeriksson@mandriva.com> 1.3.1-0.rc3.0mdv2008.0
+ Revision: 63644
- 1.3.1rc3
- fix #30714 (Security issue in proftpd (CVE-2007-2165))
- fix #31118 (Syslog contains "error setting IPV6_V6ONLY: Protocol not available")

* Mon Jul 16 2007 Andreas Hasenack <andreas@mandriva.com> 1.3.1-0.rc2.5mdv2008.0
+ Revision: 52672
- fix LDAP TLS support

* Wed Jun 27 2007 Thierry Vignaud <tvignaud@mandriva.com> 1.3.1-0.rc2.4mdv2008.0
+ Revision: 45029
- rebuild

  + Guillaume Rousse <guillomovitch@mandriva.org>
    - try to preserve /etc/proftpd-anonymous.conf file upon removal of proftpd-anonymous package
      add documentation to existing README.urpmi file instead of replacing it


* Sun Mar 11 2007 Oden Eriksson <oeriksson@mandriva.com> 1.3.1-0.rc2.3mdv2007.1
+ Revision: 141317
- disable mod_facl, it is not working

* Wed Mar 07 2007 Oden Eriksson <oeriksson@mandriva.com> 1.3.1-0.rc2.2mdv2007.1
+ Revision: 134874
- third take
- build mod_facl statically into the proftpd binary, fixes #29257

  + Thierry Vignaud <tvignaud@mandriva.com>
    - do not package huge (0.5Mb!) ChangeLog

* Wed Jan 24 2007 Oden Eriksson <oeriksson@mandriva.com> 1.3.1-0.rc2.1mdv2007.1
+ Revision: 112885
- 1.3.1rc2
- drop patches applied upstream (including the CVE-2006-6563 and CommandBufferSize patches)
- disable ipv6 per default in /etc/proftpd.conf (UseIPv6 Off)
- added some small patches to make it compile
- mod-shaper-0.6.2 -> mod-shaper-0.6.3
- drop mod_wrap 2.0.4 and use the bundled mod_wrap2 (2.0.5)
- added the devel, mod_quotatab_radius, mod_ban sub packages
- added missing post/postun stuff

* Fri Jan 05 2007 Oden Eriksson <oeriksson@mandriva.com> 1.3.0a-4mdv2007.1
+ Revision: 104615
- sync with 1.3.0-4.4mdv2007.0 from updates

* Tue Dec 19 2006 Guillaume Rousse <guillomovitch@mandriva.org> 1.3.0a-3mdv2007.1
+ Revision: 99202
- bump release
- drop anonymous subpackage
- dont ship /etc/proftpd.d content in base package (fix #27720)

* Fri Dec 08 2006 Guillaume Rousse <guillomovitch@mandriva.org> 1.3.0a-2mdv2007.1
+ Revision: 92247
- bump release
- cleanup file perm mess, standard perms are OK
  don't enforce strict perms on configuration files without reason
- drop excessive dependencies on additional modules, none is really mandatory (fix #27362)
  rewrite init scripts:
- use functions to avoid useless forks
- use less useless conditionals
- use lockfile to determine running status
- condrestart entry
  use init script condrestart entry from modules %%post and %%postun

* Wed Nov 29 2006 Oden Eriksson <oeriksson@mandriva.com> 1.3.0a-1mdv2007.1
+ Revision: 88685
- 1.3.0a (CVE-2006-5815)

* Thu Nov 23 2006 Oden Eriksson <oeriksson@mandriva.com> 1.3.0-10mdv2007.1
+ Revision: 86818
- rebuild
- merge with the update package (1.3.0-4.2mdv2007.0):
  - P100: security fix for mod_tls
  - P101: security fix for CVE-2006-5815

* Thu Nov 16 2006 Oden Eriksson <oeriksson@mandriva.com> 1.3.0-8mdv2007.1
+ Revision: 84779
- merge with my private package (P24,P25,S32)

* Thu Nov 16 2006 Oden Eriksson <oeriksson@mandriva.com> 1.3.0-7mdv2007.1
+ Revision: 84725
- proftpd-mod-shaper-0.6.2

* Fri Oct 27 2006 Oden Eriksson <oeriksson@mandriva.com> 1.3.0-6mdv2007.1
+ Revision: 73015
- make proftpd survive logrotation, mod_wrap and mod_gss wasn't updated for shared compilation (P22,P23), fixes #26729
- rebuild
- Import proftpd

* Tue Sep 19 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.3.0-4mdv2007.0
- Rebuild

* Thu Sep 14 2006 Oden Eriksson <oeriksson@mandriva.com> 1.3.0-3mdv2007.0
- change the generic pam service name after looking at debian (ftp/proftpd) (P7)
- fix upstream #2714 - mod_auth_file munges AuthUserFile, AuthGroupFile records (P10)
- fix upstream #2721 - mod_auth_unix does not behave properly when first in AuthOrder (P11)
- fix upstream #2769 - mod_auth_pam needs a patch to allow pam_group to work (P12)
- fix upstream #2784 - Ability to specify MySQL Unix domain socket path (P13)
- fix upstream #2733 - IP TOS not being set for data transfers (P14)
- fix upstream #2482 - REST in ASCII mode returns error but leaves session in inconsistent state (P15)
- fix upstream #2486 - IPv4-mapped IPv6 network ACLs not matched properly against IPv4 connections (P16)
- fix upstream #2488 - Trouble with mod_tls and DSA certificates (P17)
- fix upstream #2825 - SSL/TLS CRLs are not working properly (P18)
- fix upstream #2807 - mod_sql processes SQLLog QUIT query twice (P19)
- fix upstream #2809 - conf.h should be included before mysql.h in mod_sql_mysql.c (P20)
- fix upstream #2839 - ProFTPD seems to re-read the file two times in RETR command (P21)
- enhanced the initscript, made it quiet at startup and other fixes

* Tue Sep 05 2006 Oden Eriksson <oeriksson@mandriva.com> 1.3.0-1mdv2007.0
- rebuilt against MySQL-5.0.24a-1mdv2007.0 due to ABI changes

* Wed Aug 30 2006 Oden Eriksson <oeriksson@mandriva.com> 1.3.0-1
- 1.3.0
- rediffed P1
- drop upstream/obsolete patches
- mod_ldap_version 2.8.12
- mod_wrap_version 2.0.4
- mod_gss_version 1.3.0
- make most of the modules as DSO's
- added P3,P4 for obvious fixes
- added 2 patches from fedora extras (P5,P6)
- added additional modules (mod_autohost,mod_case,mod_clamav,mod_shaper,mod_time)
- added spec file stuff from ALTLinux (%%package, %%description)
- added ideas from the debian config
- added a README.urpmi file

* Thu Jun 15 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.10-20mdv2007.0
- rotate the correct log files (P1,S1,#23096)
- misc spec file fixes

* Fri Mar 03 2006 Michael Scherer <misc@mandriva.org> 1.2.10-19mdk
- add avahi description file
- fix pam stack

* Tue Feb 14 2006 Olivier Blin <oblin@mandriva.com> 1.2.10-18mdk
- remove duplicate xinetd entry (Neoclust, #21037)

* Mon Jan 09 2006 Olivier Blin <oblin@mandriva.com> 1.2.10-17mdk
- fix typo in initscript

* Mon Jan 09 2006 Olivier Blin <oblin@mandriva.com> 1.2.10-16mdk
- convert parallel init to LSB

* Tue Jan 03 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 1.2.10-15mdk
- add parallel init support
- fix executable-marked-as-config-file
- fix source-or-patch-not-bzipped

* Sun Nov 13 2005 Oden Eriksson <oeriksson@mandriva.com> 1.2.10-14mdk
- added P14 to make it compile against openssl-0.9.8a

* Wed Sep 07 2005 Oden Eriksson <oeriksson@mandriva.com> 1.2.10-13mdk
- rebuild

* Wed Aug 31 2005 Oden Eriksson <oeriksson@mandriva.com> 1.2.10-12mdk
- rebuilt against new openldap-2.3.6 libs

* Thu Aug 04 2005 Olivier Thauvin <nanardon@mandriva.org> 1.2.10-11mdk
- --enable-ipv6
- Fix PreReq

* Mon Aug 01 2005 Guillaume Bedot <littletux@mandriva.org> 1.2.10-10mdk
- Rebuild
- Patch10: allows to build mod_radius with gcc4

* Sat Apr 02 2005 Nicolas Chipaux <chipaux@mandrakesoft.com> 1.2.10-9mdk
- Disable sendfile (break big file transfer on i586)

* Thu Feb 10 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 1.2.10-8mdk
- fix dates in changelog (Christiaan Welvaart aka. hawkeye)

* Thu Feb 10 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 1.2.10-7mdk
- rebuilt against new openldap libs
- fix strange perms

* Tue Feb 08 2005 Buchan Milne <bgmilne@linux-mandrake.com> 1.2.10-6mdk
- rebuild for ldap2.2_7

* Fri Feb 04 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 1.2.10-5mdk
- rebuilt against new openldap libs

* Wed Nov 17 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.2.10-4mdk
- arg, mixed up, fix the correct buildrequires

* Sat Nov 13 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.2.10-3mdk
- fix buildrequires

* Thu Sep 30 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.2.10-2mdk
- buildrequires fixes for lib64 platforms

* Thu Sep 16 2004 Florin <florin@mandrakesoft.com> 1.2.10-1mdk
- 1.2.10
- add the gss module
- update the ldap and biarch patches
- remove the obsolete getfile patch
- add the ftpdctl man page
- update the BuildRequires

* Wed Jun 23 2004 Florin <florin@mandrakesoft.com> 1.2.9-7mdk
- add CFLAGS -DUSE_LDAPV3_TLS (B. Milne)

* Wed May 12 2004 Pixel <pixel@mandrakesoft.com> 1.2.9-6mdk
- rebuild for cooker

* Wed May 12 2004 Pixel <pixel@mandrakesoft.com> 1.2.9-3.2.100mdk
- use system-auth instead of pam_pwdb.so in pam.d/ftp (so that it adapts to winbind/ldap/...)

* Sat May 01 2004 Vincent Danen <vdanen@mandrakesoft.com> 1.2.9-3.1.100mdk
- security fix for ACLs with CIDR entries

